#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <ctime>
using namespace std;

#define FOR(A,B) for(int A=0; A < (int) (B);A++)

int main(int argc, char ** argv) {
	int n;
	if(argc != 2) { 
		printf("Passe como parametro apenas o tamanho de conjunto\n"); 
		return -1;
	}
	srand (time(NULL));
	n = atoi(argv[1]);
	printf("%d\n\n", n);
	vector<int> v;
	v.clear();
	FOR(i,n) v.push_back(i+1); //inicialmente, uma permutacao qualquer com numeros distintos

	FOR(i,2*n) {  //precisamos de 2*n linhas, 'n' para preferencias masculinas, e 'n' para femininas
		if(i==n) printf("\n"); //separador de matrizes de preferencias na impressao
		random_shuffle(v.begin(), v.end());	//embaralha
		FOR(i,n) printf("%d " , v[i]); //imprime a preferencia da pessoa (i%n)+1.
		printf("\n");
	}

    return 0;
}

